"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class PopulationFrequency(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "altAllele",
        "altAlleleFreq",
        "population",
        "refAllele",
        "refAlleleFreq",
        "study",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.avro.PopulationFrequency": opencb_2_9_3.PopulationFrequency,
        }

    __slots__ = [
        "altAllele",
        "altAlleleFreq",
        "population",
        "refAllele",
        "refAlleleFreq",
        "study",
        "altAlleleCount",
        "altHomGenotypeCount",
        "altHomGenotypeFreq",
        "hetGenotypeCount",
        "hetGenotypeFreq",
        "refAlleleCount",
        "refHomGenotypeCount",
        "refHomGenotypeFreq",
    ]

    def __init__(
        self,
        altAllele,
        altAlleleFreq,
        population,
        refAllele,
        refAlleleFreq,
        study,
        altAlleleCount=None,
        altHomGenotypeCount=None,
        altHomGenotypeFreq=None,
        hetGenotypeCount=None,
        hetGenotypeFreq=None,
        refAlleleCount=None,
        refHomGenotypeCount=None,
        refHomGenotypeFreq=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.PopulationFrequency model.

        :param altAllele:
        :type altAllele: str
        :param altAlleleFreq:
        :type altAlleleFreq: float
        :param population:
        :type population: str
        :param refAllele:
        :type refAllele: str
        :param refAlleleFreq:
        :type refAlleleFreq: float
        :param study:
        :type study: str
        :param altAlleleCount:
        :type altAlleleCount: None | int
        :param altHomGenotypeCount:
        :type altHomGenotypeCount: None | int
        :param altHomGenotypeFreq:
        :type altHomGenotypeFreq: None | float
        :param hetGenotypeCount:
        :type hetGenotypeCount: None | int
        :param hetGenotypeFreq:
        :type hetGenotypeFreq: None | float
        :param refAlleleCount:
        :type refAlleleCount: None | int
        :param refHomGenotypeCount:
        :type refHomGenotypeCount: None | int
        :param refHomGenotypeFreq:
        :type refHomGenotypeFreq: None | float
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
